100 REMark low level access ide stuff
110 :
120 base=49152
130 sector$=FILL$(' ',512)
140 :
150 miscin=base+HEX('3ff0')
160 miscout=miscin
170 erreg=miscin+1
180 wpreg=erreg
190 screg=erreg+1
200 snreg=screg+1
210 cyllow=snreg+1
220 cylhigh=cyllow+1
230 dhsreg=cylhigh+1
240 statreg=dhsreg+1
250 cmdreg=statreg
260 datareg=statreg+1
270 :
280 readsec=HEX('20')
290 writesec=HEX('30')
300 diag=HEX('90')
310 set_par=HEX('91')
320 ident=HEX('ec')
330 :
340 DEFine PROCedure wait
350 LOCal a,loop
360 REPeat loop
370   a=PEEK(statreg)
380   IF a<128:EXIT loop
390 END REPeat loop
400 END DEFine wait
410 :
420 DEFine PROCedure diagnose
430 LOCal a
440 wait
450 POKE cmdreg,diag
460 wait
470 a=PEEK(erreg)
480 SELect ON a
490 =1:PRINT 'OK'
500 =2:PRINT 'Register Error'
510 =3:PRINT 'Sector buffer ram failed'
520 =4:PRINT 'ECC logic error'
530 =5:PRINT 'Drive CPU error'
540 =REMAINDER :PRINT 'Unknown error'
550 END SELect 
560 END DEFine 
570 :
580 DEFine PROCedure identify_drive
590 LOCal a,a1,a2
600 wait
610 POKE cmdreg,ident
620 wait
630 FOR f=1 TO 512 STEP 2
640   a=PEEK_W(datareg)
650   a1=INT(a/256)
660   a2=a-(256*a1)
670   sector$(f)=CHR$(a1)
680   sector$(f+1)=CHR$(a2)
690 END FOR f
700 END DEFine 
710 :
720 DEFine PROCedure show_drive
730 identify_drive
740 CLS
750 PRINT 'Name   : ';sector$(55 TO 93)
760 PRINT 'Cyls   : ';(256*CODE(sector$(3)))+CODE(sector$(4))
770 PRINT 'Heads  : ';(256*CODE(sector$(7)))+CODE(sector$(8))
780 PRINT 'SecTrk : ';(256*CODE(sector$(13)))+CODE(sector$(14))
790 PRINT '8-16   : ';
800 IF CODE(sector$(98))&&1:PRINT;'8 or 16 bit':ELSE :PRINT;'8 bit only'
810 PRINT 'Mult   : ';CODE(sector$(96))
820 IF CODE(sector$(108))&&1
830   PRINT 'Trans  : Not valid'
840 ELSE 
850   PRINT 'TCyls  : ';(256*CODE(sector$(109)))+CODE(sector$(110))
860   PRINT 'THeads : ';(256*CODE(sector$(111)))+CODE(sector$(112))
870   PRINT 'TSecs  : ';(256*CODE(sector$(113)))+CODE(sector$(114))
880 END IF 
890 END DEFine 
900 :
910 DEFine PROCedure set_params(a,b,c)
920 LOCal a1,a2
930 a1=INT(a/256)
940 a2=a-(256*a1)
950 POKE cyllow,a2
960 POKE cylhigh,a1
970 POKE dhsreg,b+128+32
980 POKE screg,c
990 wait
1000 POKE cmdreg,set_par
1010 wait
1020 END DEFine set_params
